from typing import ClassVar, Optional

class Consumer:
    def __init__(self, stream_name: str, cancel_event: object = ..., polling_interval: float = ...) -> None: ...
    def flush(self) -> None: ...
    def receive(self, minimum_ts: int = ..., blocking: bool = ...) -> Optional[ReadBuffer]: ...
    def receive_string(self, minimum_ts: int = ..., blocking: bool = ...) -> str: ...
    @property
    def buffer_count(self) -> int: ...
    @property
    def buffer_size(self) -> int: ...
    @property
    def fd(self) -> int: ...
    @property
    def is_alive(self) -> bool: ...
    @property
    def is_sync(self) -> bool: ...
    @property
    def name(self) -> str: ...

class LogLevel:
    __members__: ClassVar[dict] = ...  # read-only
    DEBUG: ClassVar[LogLevel] = ...
    ERROR: ClassVar[LogLevel] = ...
    INFO: ClassVar[LogLevel] = ...
    WARNING: ClassVar[LogLevel] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __setstate__(self, state: int) -> None: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Producer:
    def __init__(self, stream_name: str, buffer_size: int, buffer_count: int, sync: bool = ..., cancel_event: object = ..., polling_interval: float = ...) -> None: ...
    def flush(self) -> None: ...
    def next_to_send(self, blocking: bool = ...) -> Optional[WriteBuffer]: ...
    def send_string(self, message: str, blocking: bool = ...) -> bool: ...
    @property
    def buffer_count(self) -> int: ...
    @property
    def buffer_size(self) -> int: ...
    @property
    def fd(self) -> int: ...
    @property
    def is_alive(self) -> bool: ...
    @property
    def is_sync(self) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def subscriber_count(self) -> int: ...

class ReadBuffer:
    def __init__(self, *args, **kwargs) -> None: ...
    @property
    def buffer_count(self) -> int: ...
    @property
    def buffer_id(self) -> int: ...
    @property
    def buffer_size(self) -> int: ...
    @property
    def data_size(self) -> int: ...
    @property
    def data_timestamp(self) -> int: ...
    @property
    def iteration(self) -> int: ...

class ThreadingEventWrapper:
    def __init__(self, cancel_event: object) -> None: ...
    def is_set(self) -> bool: ...

class WriteBuffer:
    def __init__(self, *args, **kwargs) -> None: ...
    def send(self, data_size: int) -> bool: ...
    @property
    def buffer_count(self) -> int: ...
    @property
    def buffer_id(self) -> int: ...
    @property
    def buffer_size(self) -> int: ...
    @property
    def data_size(self) -> int: ...
    @property
    def data_timestamp(self) -> int: ...
    @property
    def iteration(self) -> int: ...

def get_log_level() -> LogLevel: ...
def set_log_level(level: LogLevel) -> None: ...
